<template>
  <mgl-geojson-layer
    v-if="pointsGeoJson"
    layer-id="points"
    :layer="pointsLayer"
    type="geojson"
    source-id="points"
    :source="pointsGeoJson"
  />
</template>

<script>
  /* This layer is not in use anymore. Points are handled in mapbox studio */
  import GeoJSON from 'geojson'
  import { MglGeojsonLayer } from 'vue-mapbox'
  import mapConfig from '../../../config/map'
  import { getters } from '../../store/constants'
  import { mapGetters, mapState } from 'vuex'

  export default {
    name: 'MetrocheckLayerPoints',

    components: {
      MglGeojsonLayer,
    },

    props: {
      displayedLines: { type: Array, required: true },
    },

    data: () => ({
      displayedPoints: [],
      pointsLayer: mapConfig.layers.pointsLayer,
    }),

    computed: {
      ...mapGetters([getters.GET_POINTS_BY_LINE]),
      ...mapState(['points', 'arePointsLoading', 'arePointsLoaded']),

      pointsGeoJson: function () {
        const geojson = {
          type: 'geojson',
          cluster: true,
          clusterRadius: 10,
          data: GeoJSON.parse(this.displayedPoints, {
            Point: ['lat', 'lon'],
            include: ['name_fr', 'id'],
          }),
        }
        return geojson
      },
    },

    watch: {
      points: function () {
        console.log('LayerPoint points changed')
      },
      arePointsLoading: function () {
        console.log('LayerPoint arePointsLoading changed')
      },
      arePointsLoaded: function () {
        console.log('LayerPoint arePointsLoaded changed')
      },
    },

    async created () {
      if (!this.displayedPoints.length) {
        return this.getDisplayedPoints()
      }
    },

    methods: {
      getDisplayedPoints: async function () {
        this.displayedPoints = await this[getters.GET_POINTS_BY_LINE](this.$props.displayedLines)
      },
    },
  }
</script>

<style scoped>

</style>
